service: serverless-api-typescript

frameworkVersion: "2.0.0"

plugins:
  - serverless-dynamodb-local
  - serverless-offline

package:
  exclude:
    - .dynamodb/**
    - src/**

custom:
  serverless-offline:
    allowCache: true
  dynamodb:
    stages:
      - dev
    start:
      port: 8000
      inMemory: true
      migrate: true
    migration:
      dir: lib/migrations

provider:
  name: aws
  runtime: nodejs12.x
  region: ap-south-1
  endpointType: regional
  environment:
    DYNAMODB_TABLE: ${self:service}-${opt:stage, self:provider.stage}
    COMMIT_SHA: ${env:CI_COMMIT_SHA}
    JWT_SECRET: Hashed123$
  iamRoleStatements:
    - Effect: Allow
      Action:
        - dynamodb:Query
        - dynamodb:Scan
        - dynamodb:GetItem
        - dynamodb:PutItem
        - dynamodb:UpdateItem
        - dynamodb:DeleteItem
      Resource: "arn:aws:dynamodb:${opt:region, self:provider.region}:*:table/${self:provider.environment.DYNAMODB_TABLE}-user"

functions:
  authorizerFunc:
    handler: lib/handler.authorizer

  hello:
    handler: lib/handler.hello
    events:
      - http:
          path: hello
          method: get

  createUser:
    handler: lib/handler.createUser
    events:
      - http:
          path: user
          method: post

  getUser:
    handler: lib/handler.getUser
    events:
      - http:
          path: user
          method: get
          authorizer: authorizerFunc

  listUsers:
    handler: lib/handler.listUsers
    events:
      - http:
          path: users
          method: get

  deleteUser:
    handler: lib/handler.deleteUser
    events:
      - http:
          path: user/{id}
          method: delete

  updateUser:
    handler: lib/handler.updateUser
    events:
      - http:
          path: user/{id}
          method: put

  generateToken:
    handler: lib/handler.generateToken
    events:
      - http:
          path: auth/generateToken/{id}
          method: get

resources:
  Resources:
    TodosDynamoDbTable:
      Type: "AWS::DynamoDB::Table"
      DeletionPolicy: Retain
      Properties:
        AttributeDefinitions:
          - AttributeName: id
            AttributeType: S
        KeySchema:
          - AttributeName: id
            KeyType: HASH
        ProvisionedThroughput:
          ReadCapacityUnits: 1
          WriteCapacityUnits: 1
        TableName: ${self:provider.environment.DYNAMODB_TABLE}-user
